<?php

add_action( 'admin_init', 'cpu_register_settings' );

function cpu_register_settings() {
	register_setting( 'cpu_options', 'cpu_options', 'cpu_options_validate' );


	add_settings_section('cpu_form_settings', 'Form Settings', 'cpu_colors_text', 'cpu');
	add_settings_field('cpu_email', "Email address for contact form submissions:", 'cpu_email_string', 'cpu', 'cpu_form_settings');
	add_settings_field('cpu_enable_test', "Human Test:", 'cpu_test_string', 'cpu', 'cpu_form_settings');


	add_settings_section('cpu_social', 'Social Networking Links', 'cpu_colors_text', 'cpu');
	add_settings_field('cpu_facebook', "Facebook URL", 'cpu_facebook_string', 'cpu', 'cpu_social');
	add_settings_field('cpu_twitter', "Twitter URL", 'cpu_twitter_string', 'cpu', 'cpu_social');
	add_settings_field('cpu_gplus', "Google Plus URL", 'cpu_gplus_string', 'cpu', 'cpu_social');

	add_settings_section('cpu_text', 'Text Settings', 'cpu_colors_text', 'cpu');
	add_settings_field('cpu_calltoaction', "Call to Action Text", 'cpu_calltoaction_string', 'cpu', 'cpu_text');
	add_settings_field('cpu_success_message', "Success Message", 'cpu_success_message_string', 'cpu', 'cpu_text');

	add_settings_section('cpu_form_mailchimp', 'MainChimp Settings', 'cpu_colors_text', 'cpu');
	add_settings_field('cpu_enablemailchimp', "Enable MailChimp Signup:", 'cpu_enablemailchimp_string', 'cpu', 'cpu_form_mailchimp');
	add_settings_field('cpu_mc_label', "Sign-up checkbox Label:", 'cpu_mc_label_string', 'cpu', 'cpu_form_mailchimp');
	add_settings_field('cpu_mc_api', "MailChimp API Key:", 'cpu_mc_api_string', 'cpu', 'cpu_form_mailchimp');
	add_settings_field('cpu_mc_list', "Mailing List:", 'cpu_mc_list_string', 'cpu', 'cpu_form_mailchimp');

	add_settings_section('cpu_colors', 'Other Settings', 'cpu_colors_text', 'cpu');
	add_settings_field('cpu_position', "Window Position", 'cpu_position_string', 'cpu', 'cpu_colors');
	add_settings_field('cpu_border_color', "Popup Border Color<br><br><div id='border_color' style='width: 50px; height: 50px; margin-left: 20px;'></div>", 'cpu_border_color_string', 'cpu', 'cpu_colors');



}

function cpu_get_options() {
	$options = get_option('cpu_options');
	if(empty($options['cpu_border_color'])) {
		$options['cpu_border_color'] = "E85350";
	}
	if(empty($options['cpu_calltoaction'])) {
		$options['cpu_calltoaction'] = "Contact Us!";
	}
	if(empty($options['cpu_position'])) {
		$options['cpu_position'] = "right";
	}
	if(empty($options['cpu_email'])) {
		$options['cpu_email'] = get_bloginfo('admin_email');
	}
	if(empty($options['cpu_success_message'])) {
		$options['cpu_success_message'] = "Your message was successfully sent!";
	}

	if(empty($options['cpu_mc_label'])) {
		$options['cpu_mc_label'] = "Yes, sign up to the mailing list!";
	}

	$options['cpu_border_color'] = str_replace('#', '', $options['cpu_border_color']);

	return $options;
}

function cpu_colors_text() {
}

function cpu_border_color_string() {
	$options = cpu_get_options();

	echo "<input id='border_color_field' name='cpu_options[cpu_border_color]' size='40' type='text' value='#{$options['cpu_border_color']}' style='' />
	(Default: #e85350)
	<script>
	jQuery(document).ready(function() {
		jQuery('input#border_color_field').colorPicker({
			  format: 'hex',
			  size: 100,
			  colorChange: function(e, ui) {
				jQuery('#border_color').css({
					backgroundColor: ui.color
				})
			}
		});
		jQuery('input#border_color_field').colorPicker('setColor', '#{$options['cpu_border_color']}');


	});
	</script>

	";
}

function cpu_enablemailchimp_string() {
	$options = cpu_get_options();
	$mailchimp_checked = '';
	if(@$options['cpu_enablemailchimp'] == "enable") {
		$mailchimp_checked = "checked='checked'";
	}


	echo "	<input id='cpu_enablemailchimp' name='cpu_options[cpu_enablemailchimp]' type='checkbox' value='enable' {$mailchimp_checked} style='' /> <label for='cpu_enablemailchimp'>Yes, allow visitors to sign up via the contact form</label><br>
	";
}

function cpu_test_string() {
	$options = cpu_get_options();
	$mailchimp_checked = '';
	if(@$options['cpu_enable_test'] == "enable") {
		$cpu_enable_test = "checked='checked'";
	}

	echo "	<input id='cpu_enable_test' name='cpu_options[cpu_enable_test]' type='checkbox' value='enable' {$cpu_enable_test} style='' /> <label for='cpu_enable_test'>Yes, enable the human test (simple math question) to help prevent spam</label><br>
	";
}

function cpu_email_string() {
	$options = cpu_get_options();
	echo " <input id='cpu_email' name='cpu_options[cpu_email]' size='40' type='text' value='{$options['cpu_email']}' style='' />";
}

function cpu_mc_label_string() {
	$options = cpu_get_options();
	echo " <input id='cpu_mc_label' name='cpu_options[cpu_mc_label]' size='40' type='text' value='{$options['cpu_mc_label']}' style='' />";
}
function cpu_mc_api_string() {
	$options = cpu_get_options();
	echo " <input id='cpu_mc_api' name='cpu_options[cpu_mc_api]' size='40' type='text' value='{$options['cpu_mc_api']}' style='' />";
}

function cpu_mc_list_string() {
	$options = cpu_get_options();
	if(!empty($options['cpu_mc_api'])) {
		require_once(dirname(__FILE__) .'/lib/MCAPI.class.php');
		$api = new MCAPI($options['cpu_mc_api']);
		$lists = $api->lists();
		if(is_array($lists) && is_array($lists['data']) && sizeof($lists['data']) > 0) {
			$haslists = true;
			echo '<select name="cpu_options[cpu_mc_list]" id="cpu_mc_list">';
			foreach($lists['data'] as $list) {
				echo '<option value="'.$list['id'].'" ';
				if ($list['id'] == $options['cpu_mc_list']){
					echo "selected";
				}
				echo '>' .  $list['name'] .'</option>';
			}
			echo "</select>";

		} else {
			echo "No mailing lists found. <input id='cpu_mc_list' name='cpu_options[cpu_mc_list]'  type='hidden' value='{$options['cpu_mc_list']}' style='' />";
		}
	} else {
		echo " No valid API key. <input id='cpu_mc_list' name='cpu_options[cpu_mc_list]'  type='hidden' value='{$options['cpu_mc_list']}' style='' />";
	}
}

function cpu_calltoaction_string() {
	$options = cpu_get_options();
	echo " <input id='cpu_calltoaction' name='cpu_options[cpu_calltoaction]' size='40' type='text' value='{$options['cpu_calltoaction']}' style='' />";
}

function cpu_success_message_string() {
	$options = cpu_get_options();
	echo " <input id='cpu_success_message' name='cpu_options[cpu_success_message]' size='100' type='text' value='{$options['cpu_success_message']}' style='' />";
}

function cpu_facebook_string() {
	$options = cpu_get_options();
	echo " <input id='cpu_facebook' name='cpu_options[cpu_facebook]' size='100' type='text' value='{$options['cpu_facebook']}' style='' />";
}

function cpu_twitter_string() {
	$options = cpu_get_options();
	echo " <input id='cpu_twitter' name='cpu_options[cpu_twitter]' size='100' type='text' value='{$options['cpu_twitter']}' style='' />";
}

function cpu_gplus_string() {
	$options = cpu_get_options();
	echo " <input id='cpu_gplus' name='cpu_options[cpu_gplus]' size='100' type='text' value='{$options['cpu_gplus']}' style='' />";
}

function cpu_position_string() {
	$options = cpu_get_options();
	if($options['cpu_position'] == "left") {
		$left_checked = "checked='checked'";
		$right_checked = "";
	} else {
		$right_checked = "checked='checked'";
		$left_checked = "";
	}

	echo "Where to show the initial popup button, the bottom right, or the bottom left? Defaults to the bottom right.<br>
	<input id='cpu_position_right' name='cpu_options[cpu_position]' type='radio' value='right' {$right_checked} style='' /> <label for='cpu_position_right'>Bottom Right</label><br>
	<input id='cpu_position_left' name='cpu_options[cpu_position]'  type='radio' value='left' {$left_checked} style='' /> <label for='cpu_position_left'>Bottom Left</label>
	";
}

function cpu_options_validate($input) {
	return $input;
}